# NOTE: Derived from ./blib/lib/Ferret.pm.  Changes made here will be lost.
package Ferret;

sub MakeHTMLSummary {
	my $usage = 'Usage: Ferret::MakeHTMLSummary(\$summary, SOURCE-TYPE)';
	@_ == 2 or croak $usage;
	my($summary,$source) = @_;

	croak $usage if (ref $summary ne "SCALAR");

	if ($source =~ m/^html$/i) {
		$$summary =~ s!(<.*?)\s*color\s*=\s*#\w*(.*?>)!$1$2!gis;
		$$summary =~ s!<(/?h)(\d)>!"<$1" . ($2 > 5 ? 6 : $2 + 1) . ">"!gise;

		my $closers = "";
		foreach ($$summary =~ m/(<.*?>)/gs) {
			s/\s.*>$/>/s;

			m/<(br|p|li|hr|img|dd|dt|input|meta|!.*)>/i and next;

			if (m|^</|) {
				$closers =~ s/^(.*?)\Q$_\E(.*)$/$1$2/i;
			} else {
				s|^<|</|;
				$closers = $_ . $closers;
			}
		}

		$$summary .= $closers;
	} else {
		QuoteHTML($summary);
		$$summary = "<pre>" . $$summary . "</pre>";
	}
}



1;
