# NOTE: Derived from ./blib/lib/Ferret.pm.  Changes made here will be lost.
package Ferret;

sub RemoteQuery {
	my $usage = 'Usage: $data = Ferret::RemoteQuery(QUERY, REMOTE-URL-DIR [, ...] [, \@summaries])';
	@_ >= 2 or croak $usage;
	my $query = shift;
	my $sumref;

	croak $usage if (ref $query eq "Ferret");

	my $results = "";
	my $errors	= "";
	my $opts	= "";

	$query =~ s/\s+/+/g;
	$query = "remquery.cgi?1 " . $query;

	foreach $url (@_) {
		if (ref $url eq "ARRAY") {
			$sumref = $url;
			next;
		}

		my $data = eval { LoadHTTP($url.$query,$opts) };
		if ($@) {
			$errors .= $@ . "\n";
			next;
		}
		$data =~ s/\r//g;
		my($head) = ($data =~ m!^(.*?\n)\n!s);
#		my($type) = ($head =~ m!^Content-type:\s+(.*)!im);
		my($r,$m) = ($head =~ m!^HTTP\S*\s+(\d+)\s*(.*)$!im);
		next if ($r != 200);
		$data =~ s/^.*?\n\n//s;

		$results .= $data;
	}

#	print "Errors: '$errors', length(results)=".length($results)."\n";

	my(@matches,@summaries,@lines);

	@lines =split(/\n/,$results);
	while (@lines) {
		my $line = shift @lines;
		chop($line);
		next unless $line;
		push @matches,$line;

		$line = shift @lines;
		chop($line);
		my $size = $line;

		my $smry = "";
		while (@lines && length($smry) < $size) {
			$smry .= shift @lines;
		}
		push @summaries,$smry;
	}

	@$sumref = @summaries if (ref $sumref eq "ARRAY");
	return @matches;;
}
1;
