# NOTE: Derived from ./blib/lib/Ferret.pm.  Changes made here will be lost.
package Ferret;

sub RemoveStoppers {
	my $usage = 'Usage: $ferret->RemoveStoppers(STOPPER [, STOPPER [, ...]])';
	@_ >= 2 or croak $usage;
	my($this,@remstops) = @_;

	croak $usage if (ref $this ne "Ferret");

	return if ($Ferret::options{$this} & &OPT_NOSTOPPERS);

	my @oldstops = split(/\n/,$Ferret::stoppers{$this});
	$Ferret::stoppers{$this} = "";

	my $stops = lc(join(' ',@remstops));
	StripNonWords(\$stops);
	StripWords(\$stops, \$Ferret::stoppers{$this});
	@remstops = split(/\s+/,$stops);

	@remstops = Uniq(sort(@remstops));
	@oldstops = Uniq(sort(@oldstops));

#	print "Removing (@remstops) form (@oldstops)...\n";
	RemoveFrom(\@oldstops,\@remstops);

	$Ferret::stoppers{$this} = join("\n",@oldstops);
	$this->DBPutWords("stoppers",$Ferret::stoppers{$this});
}



###############################################################################
#
# Option management functions
#

1;
