# NOTE: Derived from ./blib/lib/Ferret.pm.  Changes made here will be lost.
package Ferret;

sub StripMIF {
	my $usage = 'Usage: Ferret::StripMIF(\$mifdata [, \$title [, \$summary [, SUMMARYSIZE]]])';
	@_ >= 1 && @_ <= 4 or croak $usage;
	my($doc,$title,$summary,$amount) = @_;

	croak $usage if (ref $doc ne "SCALAR");
	croak $usage if ($title && ref $title ne "SCALAR");
	croak $usage if ($summary && ref $summary ne "SCALAR");
	$amount = 512 unless $amount;

	if ($title) {
		$$title = "";
	}

	my @strings = ($$doc =~ m/<String\s+\`(.*?)\'>/gs);
	$$doc = join('\n',@strings);
	$$doc =~ s!<.*?>!!gs;

	if ($summary) {
#		$$doc =~ m/^(.{1,$amount})/;
		$$summary =	 substr($$doc,0,$amount);
		$$summary =~ s/[^\n]*$//s;
#		$$summary =~ s/\s+\S*$//s;
	}

	StripBadLines($doc);
	$$doc =~ s!\\x([0-9A-Fa-f]{2})!!gs;
	$$doc =~ s!\s+! !gs;
}



1;
